/*
	UApplicationSkeleton.h
	
	Copyright 1991-1992 Apple Computer, Inc.
	All rights reserved

	Change History:
	
*/

#ifndef __UAPPLICATIONSKELETON__
#define __UAPPLICATIONSKELETON__
class PascalObj TDocumentJavelin;
extern pascal void ptocstr(char* string);

//----------------------------------------------------------------------------------------
// Constants:
		
const CommandNumber cCommandHandledByApplication =	400;

//----------------------------------------------------------------------------------------
// TApplicationJavelin
//----------------------------------------------------------------------------------------

class TApplicationJavelin: public TApplication
{
	public:
		
		// Construction/Destruction
		virtual pascal void IApplicationJavelin();
		
		// Documents
		virtual pascal TDocument* DoMakeDocument(CommandNumber itsCommandNumber, TFile* itsFile );	//	Override
		
		// Commands
		virtual pascal void DoSetupMenus(); // Override		
		virtual pascal void DoMenuCommand(CommandNumber aCommandNumber); // Override
		virtual pascal void DoAppleCommand(CommandNumber aCommand,
									  		const AppleEvent& event,
									  		const AppleEvent& reply); // Override
		
		virtual pascal TDocumentJavelin* LocateDocument(long theSessionID);
//		virtual pascal void HandleMouseDown(TToolboxEvent* event);
		virtual pascal Boolean IsThisMyDoc(TDocument* theDoc);
};	

//-------------------Heart Beat stuff-----------------------------------------------------------------

class TCohandler : public TEventHandler {
protected:
	virtual pascal void ICohandler();
	virtual pascal void Free();
		// install and remove as application cohandler
};

//------------------Heart Beat stuff----------------------------------------------------------------

class TIdleBeeper : public TCohandler {

public:
	long fLastHeartBeat;

	virtual pascal void IIdleBeeper();
	virtual pascal Boolean DoIdle(IdlePhase phase);
};

#endif
