// UClientCommands.cp
// Copyright 1991-1992 Apple Computer, Inc.


#ifndef __UDOCUMENTSKELETON__
#include "UDocumentSkeleton.h"
#endif

#ifndef __UOBJECTSSKELETON__
#include "UObjectsSkeleton.h"
#endif

#ifndef __UCOMMANDTSKELETON__
#include "UCommandSkeleton.h"
#endif

#ifndef __AUXAESUITE__
#include "AUXAESuite.h"
#endif

#ifndef __UCLIENTCOMMANDS__
#include "UClientCommands.h"
#endif

#ifndef __UDISCUSVIEW__
#include "UDiscusView.h"
#endif

#ifndef __UICONSUPERVIEW__
#include "UIconSuperView.h"
#endif

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

#ifndef PACKAGES
#include <Packages.h>
#endif

//--------------------------------------------------------------------------------------------------
#pragma segment AEvent
pascal void TConfigCommand::Initialize()	// Override
{
	inherited::Initialize();
}

//--------------------------------------------------------------------------------------------------
#pragma segment AEvent
pascal void TConfigCommand::DoIt()	// Override
{
	ConfigTypes	iter;
	short 		subiter;
	long 		count;
	short 		dirtyFlag;
	DescType 	actualType;
	long 		actualSize;
	Boolean		refresh = FALSE;
	
	AEDescList	theSubList;		// each array, ie ConfigList
	AERecord	theRecord;		// One object on server.
	AppleEvent	theEvent = fMessage->fMessage;
	DescType 	listType[] = {keyVGList,keyPVList, keyLVList, keyFSList};
	CStr255 errorMsg, aString;
	
	TDocumentSkeleton* itsDoc = (TDocumentSkeleton*)fContext;	
	
	// I believe the best course of action is to parse out each array,
	// and let the object it describes modify itself accordingly.
	for (iter = kVG; iter <= kFS; iter++) {
		if (AEGetParamDesc(theEvent, listType[iter], typeAEList, theSubList) == errAEDescNotFound)
			continue; // no list of type x
			
		FailOSErr(AECountItems(theSubList, count));
		for (subiter = 1; subiter <= count; subiter++) {
			TDiscusObject* obj;
			char name[255];
			
			FailOSErr(AEGetNthDesc(theSubList, subiter, typeAERecord, actualType, theRecord));
			FailOSErr(AEGetKeyPtr(theRecord, keyDirty, typeShortInteger, 
								  actualType, (Ptr)&dirtyFlag, sizeof(short), actualSize));
			FailOSErr(AEGetKeyPtr(theRecord, keyName, typeChar, 
								  actualType, name, 255, actualSize));
			name[actualSize] = NULL;
			
			NumToString(subiter, aString);
			if  (dirtyFlag == kNew)
				{

				obj = itsDoc->CreateDiscusObject(listType[iter], name);
				}
			else
				{

				obj = itsDoc->FindDiscusObject(listType[iter], name);
				if (!obj)
					{
					obj = itsDoc->CreateDiscusObject(listType[iter], name);
					}
				}

			// The object may not exist as its owning object (VG)
			// may have been deleted previously
			if (IsObject(obj))
				{
				obj->UpdateFromAppleEvent(theRecord, itsDoc, dirtyFlag);
				}
		} // subiter
	} // iter
	itsDoc->CommandCompleted();
	
	if (itsDoc->ViewsNeedRefresh()) {
		itsDoc->GetIconView()->Refresh();		// new or removed objects
		itsDoc->GetIconView()->ReCalc();
	} 
	itsDoc->GetIconView()->ForceRedraw();	// or updates.	
	itsDoc->ResetRefresh();
}
