/*
	UClientCommands.h
	
	Copyright 1991-1992 Apple Computer, Inc.
	All rights reserved
 */

#ifndef __UCLIENTCOMMANDS__
#define __UCLIENTCOMMANDS__

class PascalObj TAppleEvent;
class PascalObj TDocument;
class PascalObj TDocumentSkeleton;
class PascalObj	 TDiscusObject;

//----------------------------------------------------------------------------------------------

#define SUCCESS(code) (*code == 'S')

// used to stuff toolbox returns into CStrings
#define UNBUF(field) {\
					 buf[actualSize] = NULL;\
					 field = buf;\
}
//----------------------------------------------------------------------------------------------

enum  ConfigTypes {
	kVG = 0, 
	kPV, 
	kLV,
	kFS
};

// from the server
enum {
	kClean 		= 0x0,
	kNew		= 0x01,
	kUpdate		= 0x02,
	kDelete 	= 0x03,
};

// passed on to TObject::Changed()
// Changed takes event numbers as change IDs and MacApp reserves 0-999.

const EventNumber userEventBase = 1000;
enum {
	mClean = userEventBase,	// += kClean
	mNew,
	mUpdate,
	mDelete,
	mMigrate 	// when PVs get assigned or unassigned to VG
};

//----------------------------------------------------------------------------------------------
class TConfigCommand: public TServerCommand
{	
public:
	virtual pascal void Initialize();	// Override
	virtual pascal void DoIt();		// Override
};

//-----------------------------------------------------------------------------------------------
#endif