//----------------------------------------------------------------------------------------
// UCommandPolevault.cp
// Copyright 1991-1992 Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UCOMMANDPolevault__
#include "UCommandPolevault.h"
#endif

#ifndef __UAPPLICATIONPolevault__
#include "UApplicationPolevault.h"
#endif

#ifndef __UDOCUMENTPolevault__
#include "UDocumentPolevault.h"
#endif

#ifndef __UPolevaultVIEW__
#include "UPolevaultView.h"
#endif

#ifndef __ERRORS__
#include <Errors.h>
#endif

#ifndef __UREMOTECOMMANDS__
#include "URemoteCommands.h"
#endif

#ifndef __PPCTOOLBOX__
#include <PPCToolbox.h>
#endif

// *********************************  Constants  ************************************* //  all new rD

const short  ppcInternetLocation 	= 3;
TApplicationPolevault* gApplicationPolevault;

// *********************************  Utilities  ************************************* //

//--------------------------------------------------------------------------------------------------

/*
 *	MyPPCBrowserFilter
 *
 *	Thanks to Eric Berhdahl & Eric Soldan and his Kibitz application for the tips
 *	on how to implement this funciton.
 */
 
#pragma segment ADoCommand
static pascal Boolean MyPPCBrowserFilter(LocationNamePtr /* theLocation */, PortInfoPtr thePortInfo)
{
	OSType	type;

	if (thePortInfo->name.portKindSelector == ppcByString)
	{
		BlockMove(thePortInfo->name.u.portTypeStr + 1, Ptr(&type), sizeof(type));
			// The BlockMove is so that we don't get an address error
			// on a 68000-based machine due to referencing a long at
			// an odd-address.
		if (type == kSignature)
			return TRUE;
	}
	return FALSE;
}

// *********************************  TLookupLauncher  ************************************* //

//--------------------------------------------------------------------------------------------------
#pragma segment ADoCommand
pascal void TLookupLauncher::DoIt()	// OVERRIDE
{
	// This command runs the PPCBrowser dialog. If not canceled by the user,
	// it opens the modeless Lookup dialog.
	
	PortInfoRec		thePortInfo;
	TargetID		theTargetID;
	OSErr theErr;
	CStr255 		windowTitle;
	FailInfo fi;

for (fDocument->nAddrs = 0; fDocument->nAddrs < kMaxHosts; fDocument->nAddrs++)
{
		theErr = PPCBrowser("\pSelect a Unix Server.", "\pServers",
							 FALSE /* defaultSpecified */, theTargetID.location, thePortInfo,
							 MyPPCBrowserFilter, "\pUNIX PPCToolbox");
		if (theErr == noErr)
		{
		}
		else if (theErr != userCanceledErr)
			FailOSErr(theErr);
		else
			break;     //used to be return

	theTargetID.name = thePortInfo.name;

		switch (theTargetID.location.locationKindSelector)
			{
			case ppcNoLocation:						// my own machine
				break;
			case ppcNBPLocation:					// we are handling this case
					fDocument->hostAddr[fDocument->nAddrs].descriptorType = typeTargetID;
					PtrToHand((Ptr)&theTargetID, fDocument->hostAddr[fDocument->nAddrs].dataHandle, sizeof(theTargetID));
				break;
			default:
				break;
				}

//		InvalidateMenus();    //global routine... not sure who the target is in this case.  we'll see.
//		this->WakeupServer();


//		if  (fDocument->Connected())
//					this->CheckVersion();

	}   //end next loop
}


//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand
pascal void TLookupLauncher::ILookupLauncher(CommandNumber aCommandNumber,
										   TDocumentPolevault* theDoc)
{
	this->ICommand(aCommandNumber, NULL, kCantUndo, kDoesNotCauseChange, NULL);  //rD was
	fDocument = theDoc;
}

//--------------------------------------------------------------------------------------------------
//#pragma segment ASelCommand
//pascal void TLookupLauncher::WakeupServer()
//{
//		for (int i = 0; i < fDocument->nAddrs; i++)
//		{
//			TWakeupCommand* aCommand = new TWakeupCommand;
//			aCommand->IWakeupCommand(fDocument, i);
//			fDocument->PostCommand(aCommand);
//		}
//}
//--------------------------------------------------------------------------------------------------
//#pragma segment ASelCommand
//pascal void TLookupLauncher::CheckVersion()
//{
//		for (int i = 0; i < fDocument->nAddrs; i++)
//		{
//			TPolevaultVersionCmd* aCommand = new TPolevaultVersionCmd;
//			aCommand->IPolevaultVersionCmd(this->fDocument, i);
//			fDocument->PostCommand(aCommand);
//		}
//}


//--------------------------------------------------------------------------------------------------
#pragma segment AEvent
pascal void TConfigCommand::DoIt()	// Override
{
//	long 		actualSize;
	
	AppleEvent	theEvent = fMessage->fMessage;
	CStr255 errorMsg, aString;
	
	TDocumentPolevault* itsDoc = (TDocumentPolevault*)fContext;	
}
//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand

pascal void TCommandMandel::Initialize() // Override 
{
	inherited::Initialize();
	
	fDocument = NULL;
}

//--------------------------------------------------------------------------------------------------
#pragma segment ASelCommand

pascal void TCommandMandel::ICommandMandel(CommandNumber itsCommandNumber,
												TDocumentPolevault* itsDocument)
{
	this->ICommand(itsCommandNumber,itsDocument,kCanUndo,kCausesChange,itsDocument);
	fDocument = itsDocument;
}

//--------------------------------------------------------------------------------------------------
#pragma segment ADoCommand

pascal void TCommandMandel::DoIt() // Override 
{
	fDocument->SetBounds();
}

//--------------------------------------------------------------------------------------------------
#pragma segment ADoCommand

pascal void TCommandMandel::RedoIt(void) // override 
{
	inherited::RedoIt();	// TCommand::RedoIt simply calls DoIt, but this is not always adequate
}

//--------------------------------------------------------------------------------------------------
#pragma segment ADoCommand

pascal void TCommandMandel::UndoIt() // Override 
{
	SysBeep(2);
	SysBeep(2);
}

