//----------------------------------------------------------------------------------------
// UPolevaultAppleEvent.cp
// Copyright 1991-1992 Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UPolevaultAPPLEEVENT__
#include "UPolevaultAppleEvent.h" 
#endif

#ifndef __UAPPLICATIONPolevault__
#include "UApplicationPolevault.h"
#endif

#ifndef __UDOCUMENTPolevault__
#include "UDocumentPolevault.h"
#endif

#ifndef __UPolevaultVIEW__
#include "UPolevaultView.h"
#endif

#ifndef __ERRORS__
#include <Errors.h>
#endif

#ifndef __MACAPPGLOBALS__
#include <UMacAppGlobals.h>
#endif

#ifndef __PACKAGES__
#include <Packages.h>
#endif

class PascalObj TDocumentPolevault;

pascal void TPolevaultAppleEvent::IPolevaultAppleEvent(const AEEventClass itsEventClass,
									 const AEEventID itsEventID,
									 const AEAddressDesc& itsAddress,
									 long itsSendingMode,
									 short docRefNum)
{
	fPortRefNum = docRefNum;
	inherited::IAppleEvent(itsEventClass, itsEventID, itsAddress, itsSendingMode);

};

pascal TAppleEvent* TPolevaultAppleEvent::Send()
{
	AppleEvent theMessage = fMessage;
	AppleEvent theReply;
	TAppleEvent* result = NULL;
	
	VOLATILE(theReply);
	
	FailOSErr(AECreateDesc(typeNull, NULL, 0, theReply));
	
	OSErr err =AESend(theMessage, theReply, fSendingMode, fPriority, fTimeoutVal,
					 gMacAppAppleEventIdleProc, gMacAppAppleEventFilterProc);
	
	if (err == noErr)
		{
		//yubba dubba doo?
		}
	else if (err == sessClosedErr  /* -917*/)
		{
		return result;    //let macapp take care of everything???
		}
	else if (err != userCanceledErr /*-128*/)    // && (fSendingMode == 129 /* dont reconnect for quitcmd */))
		{
		CStr255 theError;
		NumToString(err, theError);
		theError += " - error sending the last appleEvent";
		PolevaultErrorBox(theError);
		}
	else
		{
		TDocumentPolevault* theDoc = ((TApplicationPolevault*) gApplication)->LocateDocument((long) fPortRefNum);

		theDoc->Disconnect();
		return result;
		}

	if ((this->GetSendingMode() & kAEReplyModeMask) == kAEWaitReply)
	{
		//	If we were waiting for a reply to our AppleEvent, instantiate a
		//	TAppleEvent and initialize it with theReply.
		FailInfo fi;
		if (fi.Try())
		{
			result = new TAppleEvent;
			result->InitializeFromMessage(theReply, TRUE);
			fi.Success();
		}
		else
		{
			AEDisposeDesc(theReply);
			fi.ReSignal();
		}
	}
	else
		AEDisposeDesc(theReply);

	return result;
} // TAppleEvent::Send

