// URemoteCommands.h
// Copyright 1991-1994 Apple Computer, Inc.

#ifndef __UREMOTECOMMANDS__
#define __UREMOTECOMMANDS__

class PascalObj TAppleEvent;
class PascalObj TPolevaultAppleEvent;
class PascalObj TDocumentPolevault;

const long 	cRemoteCommand = 998;


//----------------------------------------------------------------------------------------------
//	TPolevaultClientCommand
//----------------------------------------------------------------------------------------------
class TPolevaultClientCommand: public TClientCommand
{
protected:
	Boolean 	fPostage;
public:
	virtual pascal void 		IPolevaultClientCommand(TDocumentPolevault* itsDocument, 
												const int theKey,
												TObject* toNotify, int whichServer);			// Override
	virtual pascal void 		ProcessReply(TAppleEvent* theReply);		// Override
	virtual pascal TAppleEvent* SendMessage();							// Override	
};
//----------------------------------------------------------------------------------------------
//	kAEQuit
//----------------------------------------------------------------------------------------------
class TQuitCmd: public TClientCommand
{
public:
	virtual pascal void	IQuitCmd(TDocumentPolevault* itsDoc, int whichServer);						// Override
};

//----------------------------------------------------------------------------------------------
//	kAENull
//----------------------------------------------------------------------------------------------
class TWakeupCommand: public TPolevaultClientCommand
{
public:
	virtual pascal void	IWakeupCommand(TDocumentPolevault* itsDoc, int whichServer);
};
//----------------------------------------------------------------------------------------------
//	kAENull   - no reply - no command in progress dialog...
//----------------------------------------------------------------------------------------------
class THeartBeatCommand: public TClientCommand
{
public:
	virtual pascal void	IHeartBeatCommand(TDocumentPolevault* itsDoc, int whichServer);
};


#endif