/* misc.h -- misc defines for misc.c (Mandeld UNIX daemon)
 *
 * %W%
 *
 * Author: Scott Mulligan
 * Copyright 1993 Apple Computer, Inc.
 * All Rights Reserved.
 *
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF APPLE COMPUTER, INC.
 * The copyright notice above does not evidence any actual or
 * intended publication of such source code.
 *
 */


#define ACLIST		"/symbiotics/sysadm.aclist"
#define LOCKFILE	"/symbiotics/mandeld.lock"
#define SIZEOFPID	12


#define DATABUFSIZE	64*1024


/* Message indices for tell_mac() */
#define ALREADY_LOCKED  1
#define CANT_LOCK       2
#define UNKNOWN_ERROR   3


/* timeout values for client HEARTBEAT know-when-to-die scheme
 *
 * we check to see how long it has been since we heard from the client
 * every "HEARTBEAT_CHECK" number of seconds.  This should correspond
 * to how often the we expect the client to send us HEARTBEAT events.
 *
 * we send a HEARTBEAT event to the client every "HEARTBEAT_SEND"
 * number of seconds.
 *
 * if we "miss" MAX_MISSED_HEARTBEATS in a row...
 * we will assume that the client has gone away
 */
#define HEARTBEAT_CHECK		30
#define HEARTBEAT_SEND		HEARTBEAT_CHECK
#define MAX_MISSED_HEARTBEATS	6

#ifndef SUCCESS
#define SUCCESS 0
#endif
