#pragma once

class CAERepeater : public LModelDirector
{
// constructor/destructor
public:
	CAERepeater(LModelObject* inDefaultModel);
	~CAERepeater(void);
	
// overides
public:
	void HandleAppleEvent(const AppleEvent& inAppleEvent, AppleEvent& outReply, Int32 inRefCon);
	
	inline void HandleOpenOrPrintEvent(const AppleEvent&, AppleEvent&, Int32)
	{
		ThrowOSErr_(errAEEventNotHandled);
	}
	
	inline void HandleCreateElementEvent(const AppleEvent& inAppleEvent, AppleEvent& outReply, Int32 inRefCon)
	{
		HandleAppleEvent(inAppleEvent, outReply, inRefCon);
	}
							

// interface
public:
	static CAERepeater* GetAERepeater(void);

	static void OpenConnection(TargetID& outTarget);

// utility functions
private:
	static void PrintAEDesc(const AEDesc& inAEDesc);
		
// storage
private:
	static Boolean sDebuggingEnabled;
};
